/* -------------------------------------------------
Beispielskript zur SNEK 2 im April 2013 in Nrnberg
Autor: Bernd Jungbluth
Keine Gewhrleistung, keine Haftung
------------------------------------------------- */

-- Ausgabe der Metadaten



-- Alle definierten Sitzungen
SELECT	name, event_retention_mode_desc, 
		max_memory, max_event_size, startup_state
FROM	sys.server_event_sessions;



-- Alle Pakete der Erweiterten Ereignisse
SELECT	name, [description] FROM sys.dm_xe_packages;



-- Alle Ereignisse
SELECT	name, description, object_type
FROM	sys.dm_xe_objects 
WHERE object_type = 'event';

-- Alle Ereignisse pro Paket
SELECT	P.Name As Paket, O.Name As Ereignis, O.description
FROM	sys.dm_xe_packages P INNER JOIN sys.dm_xe_objects O
		ON P.guid = O.package_guid 
WHERE	O.object_type = 'event'
ORDER BY P.Name, O.Name;

-- Bestimmte Ereignisse suchen
SELECT	name, description, object_type 
FROM	sys.dm_xe_objects 
WHERE	object_type = 'event' AND name LIKE '%completed%' 
ORDER BY name;



-- Alle Ereignisfelder
SELECT	[object_name], name, description, 
		column_type, type_name 
FROM	sys.dm_xe_object_columns
ORDER BY [object_name];

-- Alle Ereignisfelder eines Ereignisses
SELECT	O.name As Ereignis, 
		C.name As EreignisFeld, C.description, C.column_type As Typ 
FROM	sys.dm_xe_objects O INNER JOIN sys.dm_xe_object_columns C
		ON	O.package_guid = C.object_package_guid
		AND O.name = C.[object_name] 
WHERE	O.object_type = 'event'  AND O.Name = 'sp_statement_completed'
ORDER BY O.name, C.column_type, C.name;



-- Alle Aktionen
SELECT	name, description, object_type, type_name, type_size 
FROM	sys.dm_xe_objects WHERE object_type = 'action'
ORDER BY name;

-- Alle Aktionen vom Paket "sqlserver"
SELECT	P.Name As Paket, O.Name As Ereignis, O.description
FROM	sys.dm_xe_packages P INNER JOIN sys.dm_xe_objects O
		ON P.guid = O.package_guid 
WHERE	O.object_type = 'action'
		AND p.Name = 'sqlserver'
ORDER BY P.Name, O.Name;



-- Alle Prdikate vom Typ "pred_source" pro Paket
SELECT	P.Name As Paket, O.Name As Ereignis, O.description
FROM	sys.dm_xe_packages P INNER JOIN sys.dm_xe_objects O
		ON P.guid = O.package_guid 
WHERE	O.object_type = ('pred_source')
ORDER BY P.Name, O.Name;



-- Alle Typen
SELECT	name, description, object_type, type_size
FROM	sys.dm_xe_objects 
WHERE	object_type IN ('type')
ORDER BY name;



-- Alle Zuordnungen zum Ereignisfeld "object_type" vom Ereignis "sp_statement_completed"
SELECT	C.[object_name] As Ereignis, C.name As Ereignisfeld,  
		M.map_key As Wert, map_value As Bezeichnung
FROM	sys.dm_xe_object_columns C INNER JOIN sys.dm_xe_map_values M
		ON	C.object_package_guid = M.object_package_guid AND C.name = M.Name
WHERE	C.[object_name] = 'sp_statement_completed'
		AND C.name = 'Object_Type'
ORDER BY C.[object_name], C.column_type, C.name;



-- Alle Ziele
SELECT	name, description, object_type
FROM	sys.dm_xe_objects WHERE object_type = 'target';

-- Alle Ziele pro Paket
SELECT	P.Name As Paket, O.Name As Ereignis, O.description
FROM	sys.dm_xe_packages P INNER JOIN sys.dm_xe_objects O
		ON P.guid = O.package_guid 
WHERE	O.object_type = 'target'
ORDER BY P.Name, O.Name;
