/* -------------------------------------------------
Beispielskript zur SNEK 2 im April 2013 in Nrnberg
Autor: Bernd Jungbluth
Keine Gewhrleistung, keine Haftung
------------------------------------------------- */

-- Erstellen der XEvent-Sitzung "Trigger"
-- Protokolliert wann welche Trigger ausgefhrt wurden, 
-- inklusive der vom Trigger ausgefhrten SQL-Anweisungen


-- Sitzung lschen, falls bereits vorhanden
IF EXISTS(SELECT * FROM sys.server_event_sessions WHERE name='TriggerAusfuehrung')
BEGIN
	DROP EVENT SESSION TriggerAusfuehrung ON SERVER;
END
GO
-- Sitzung anlegen
CREATE EVENT SESSION TriggerAusfuehrung ON SERVER 
    ADD EVENT sqlserver.sp_statement_completed 
    (	SET collect_statement=1, collect_object_name=1
        ACTION (sqlserver.sql_text, sqlserver.client_hostname, sqlserver.username, 
				sqlserver.database_id, sqlserver.database_name)
        WHERE	sqlserver.database_id = 12
				AND object_type = 21076 --> TRIGGER
    )  
    ADD TARGET package0.ring_buffer (SET max_memory = 4096),
	ADD TARGET package0.event_file (SET filename=N'D:\SNEK2\Ergebnisse\TriggerAusfuehrung.xel')
-- Latenzzeit aus Demozwecken auf 10 Sekunden
WITH (MAX_DISPATCH_LATENCY=10 SECONDS);


-- Sitzung starten
ALTER EVENT SESSION TriggerAusfuehrung ON SERVER STATE=START;



-- Testen
USE SNEK
GO

-- INSTEAD OF-Trigger - verhindert Dateneingabe mit zu hohen Rabatt
INSERT INTO dbo.Bestelldetails ([Bestell-Nr], [Artikel-Nr], Einzelpreis, Anzahl, Rabatt)
	 VALUES (11077, 9, '6.5', 5, '0.26');
GO
-- INSTEAD OF-Trigger - verhindert Dateneingabe mit zu hohen Rabatt, jedoch nicht bei diesem Mitarbeiter
INSERT INTO dbo.Bestelldetails ([Bestell-Nr], [Artikel-Nr], Einzelpreis, Anzahl, Rabatt)
	 VALUES (10502, 12, '6.5', 5, '0.55');
GO


-- Sitzung stoppen
-- ALTER EVENT SESSION TriggerAusfuehrung ON SERVER STATE=STOP;
