/* -------------------------------------------------
Beispielskript zur SNEK 2 im April 2013 in Nrnberg
Autor: Bernd Jungbluth
Keine Gewhrleistung, keine Haftung
------------------------------------------------- */

-- Erstellen der XEvent-Sitzung "Fehler"
-- Protokolliert wann welche Fehler ausgelst wurden, 
-- zzgl. der Eintrge im SQL Server-Fehlerprotokoll


-- Sitzung lschen, falls bereits vorhanden
IF EXISTS(SELECT name FROM sys.server_event_sessions WHERE name = 'Fehler')
BEGIN
	DROP EVENT SESSION Fehler ON SERVER;
END;
-- Sitzung anlegen
CREATE EVENT SESSION Fehler ON SERVER
	ADD EVENT sqlserver.error_reported	 
	(	ACTION (sqlserver.client_hostname, sqlserver.database_id, 
				 sqlserver.database_name, sqlserver.sql_text, sqlserver.username)
		-- Severity kleiner gleich 10 sind Informationsmeldungen, grer 20 bereits in "system_health"
		 WHERE (sqlserver.database_id = 12 AND (severity > 10 AND severity <= 20))
	),
	ADD EVENT sqlserver.errorlog_written 
	(	ACTION (sqlserver.client_hostname)
	)
	ADD TARGET package0.event_file (SET filename=N'D:\SNEK2\Ergebnisse\Fehler.xel')
-- Latenzzeit aus Demozwecken auf 10 Sekunden
WITH (MAX_DISPATCH_LATENCY=10 SECONDS);


-- Sitzung starten
ALTER EVENT SESSION Fehler ON SERVER STATE=START;



-- Testen
USE SNEK
GO

-- Fehler produzieren
RAISERROR('Nobody is perfect', 16, 1)
GO 
RAISERROR('Nobody is perfect', 16, 1)
GO 

DECLARE @Fehler nvarchar(100)
SELECT @Fehler = FORMATMESSAGE('Dieser Fehler wurde Ihnen prsentiert von THROW');
THROW 50001, @Fehler, 1;
GO

SELECT * FROM TabellenNameNichtBekannt;
GO

SELECT Alles FROM dbo.Kunden;
GO

-- Zum Test fr den Eintrag in das SQL Server-Fehlerprotokoll
-- Neue Anmeldung am SQL Server Management Studio - mit falschem Kennwort


-- Sitzung stoppen
-- ALTER EVENT SESSION Fehler ON SERVER STATE = STOP;
						 
