/* -------------------------------------------------
Beispielskript zur SNEK 2 im April 2013 in Nrnberg
Autor: Bernd Jungbluth
Keine Gewhrleistung, keine Haftung
------------------------------------------------- */


-- Erstellen der XEvent-Sitzung "AehnlicheSqlAnweisungen"
-- Protokolliert SQL-Anweisungen und ergnzt diese mit  
-- einem Hashwert, der hnliche SQL-Anweisungen kennzeichnet


-- Informationen zur Aktion "query_hash"
SELECT	object_type, name, description 
FROM	sys.dm_xe_objects 
WHERE	object_type = 'action' AND name = 'query_hash';


-- Sitzung lschen, falls bereits vorhanden
IF EXISTS(SELECT name FROM sys.server_event_sessions WHERE name='AehnlicheSqlAnweisungen')
BEGIN
	DROP EVENT SESSION AehnlicheSqlAnweisungen ON SERVER;
END
GO
-- Sitzung anlegen
CREATE EVENT SESSION AehnlicheSqlAnweisungen ON SERVER 
    ADD EVENT sqlserver.sql_statement_completed
    (	SET collect_statement=1	
		ACTION (sqlserver.client_hostname, sqlserver.username, sqlserver.query_hash) 
        WHERE   sqlserver.database_id = 12
	)
    ADD TARGET package0.ring_buffer (SET max_memory = 4096),
	ADD TARGET package0.event_file (SET filename = 'D:\SNEK2\Ergebnisse\HauefigeSqlAnweisungen.xel') 
-- Latenzzeit aus Demozwecken auf 10 Sekunden
WITH (MAX_DISPATCH_LATENCY=10 SECONDS); 


-- Ausgabe der Konfiguration
SELECT	Sitzungen.name As Sitzung, Ereignisse.package As Paket, Ereignisse.name As Ereignis,
		Ereignisse.predicate As Prdikate, Aktionen.name As Aktionen, 
		Ziele.name As Ziele, Eigenschaften.value As Speicher
FROM	sys.server_event_sessions Sitzungen
		INNER JOIN sys.server_event_session_events Ereignisse 
				ON Sitzungen.event_session_id = Ereignisse.event_session_id
		INNER JOIN sys.server_event_session_actions Aktionen
				ON Sitzungen.event_session_id = Aktionen.event_session_id
		INNER JOIN sys.server_event_session_targets Ziele
				ON Sitzungen.event_session_id = Ziele.event_session_id
		INNER JOIN sys.server_event_session_fields Eigenschaften
				ON Sitzungen.event_session_id = Eigenschaften.event_session_id
			  AND Ziele.target_id = Eigenschaften.[object_id] 
WHERE	Sitzungen.name = 'HauefigeSqlAnweisungen'
ORDER BY Ereignis, Ziele, Aktionen;


-- Sitzung starten
ALTER EVENT SESSION AehnlicheSqlAnweisungen ON SERVER STATE=START;



-- Testen
USE SNEK
GO
SELECT * FROM dbo.Artikel;
GO
SELECT * FROM dbo.Artikel;
GO
SELECT * FROM dbo.Artikel WHERE [Artikel-Nr] = 1;
GO
SELECT * FROM dbo.Artikel WHERE [Artikel-Nr] = 2;
GO
SELECT * FROM dbo.Artikel WHERE [Artikel-Nr] = 3;
GO
SELECT * FROM dbo.Artikel WHERE [Artikel-Nr] = 4;
GO
SELECT * FROM dbo.Artikel WHERE [Artikel-Nr] = 5;
GO
SELECT * FROM dbo.Artikel WHERE [Artikel-Nr] = 6;
GO
SELECT * FROM dbo.Artikel WHERE [Artikel-Nr] = 7;
GO
SELECT * FROM dbo.Artikel;
GO
SELECT * FROM dbo.Kunden WHERE [Kunden-Code] = 'ALFKI';
GO
SELECT * FROM dbo.Kunden;
GO


-- Sitzung stoppen
-- ALTER EVENT SESSION AehnlicheSqlAnweisungen ON SERVER STATE=STOP;