/* -------------------------------------------------
Beispielskript zur SNEK 2 im April 2013 in Nrnberg
Autor: Bernd Jungbluth
Keine Gewhrleistung, keine Haftung
------------------------------------------------- */

-- Auswerten der XEvent-Sitzung "LanglaufendeAbfragen"
-- Quelle: Ereignnisdatei
-- Die Daten werden mit einer CTE ausgegeben, um das Ergbnis mit der DMF sys.dm_exec_query_plan zu ergnzen.
-- Die DMF sys.dm_exec_query_plan liefert den Ausfhrungsplan zur SQL-Anweisung.

WITH cteErgebnis (Ereignis, Zeitpunkt, DatenbankID, Datenbank, 
				  PhysikalischeLesevorgaenge, LogischeLesevorgaenge, DauerInSek, CpuInSek,
				  AnzahlZeilen, SqlAnweisung, Ausfuehrungsplan, Ergebnis)
AS
(
SELECT	xmlWert.value('(event/@name)[1]', 'nvarchar(512)') AS Ereignis,
		DATEADD(hh, DATEDIFF(hh, GETUTCDATE(), CURRENT_TIMESTAMP), 
				xmlWert.value('(event/@timestamp)[1]', 'datetime2')) AS Zeitpunkt,
		xmlWert.value('(event/action[@name="database_id"]/value)[1]','int') AS Datenbank_ID,
		xmlWert.value('(event/action[@name="database_name"]/value)[1]', 'nvarchar(256)') AS Datenbank,
		xmlWert.value('(event/data[@name="physical_reads"]/value)[1]', 'bigint') AS PhysikalischeLesevorgaenge,
		xmlWert.value('(event/data[@name="logical_reads"]/value)[1]', 'bigint') AS LogischeLesevorgaenge,
		CAST((xmlWert.value('(event/data[@name="duration"]/value)[1]', 'bigint') / 1000000.0) As decimal(6,2)) AS DauerInSek,
		CAST((xmlWert.value('(event/data[@name="cpu_time"]/value)[1]', 'bigint') / 1000000.0) As decimal(6,2)) AS CpuInSek,
		xmlWert.value('(event/data[@name="row_count"]/value)[1]', 'bigint') AS AnzahlZeilen,
		xmlWert.value('(event/data[@name="statement"]/value)[1]', 'nvarchar(max)') AS SqlAnweisung,
		xmlWert.value('(event/action[@name="plan_handle"]/value)[1]', 'nvarchar(max)') AS Ausfuehrungsplan,
		Ergebnis
FROM
		(SELECT CAST(event_data AS XML) Ergebnis
		 FROM	sys.fn_xe_file_target_read_file('D:\SNEK2\Ergebnisse\LanglaufendeAbfragen*.xel', NULL, NULL, NULL)) Ergebnisdaten
		 CROSS APPLY Ergebnis.nodes ('.') AS xmlErgebnis (xmlWert)
)
SELECT	Ereignis, Zeitpunkt, DatenbankID, Datenbank, PhysikalischeLesevorgaenge, LogischeLesevorgaenge, 
		DauerInSek, CpuInSek, AnzahlZeilen, SqlAnweisung,  AP.query_plan AS Ausfuehrungsplan, Ergebnis
FROM	cteErgebnis E 
		OUTER APPLY sys.dm_exec_query_plan(CONVERT(varbinary(max), Ausfuehrungsplan, 2)) AP;