/* -------------------------------------------------
Beispielskript zur SNEK 2 im April 2013 in Nrnberg
Autor: Bernd Jungbluth
Keine Gewhrleistung, keine Haftung
------------------------------------------------- */

-- Erstellen der XEvent-Sitzung "SperrenZaehlen"
-- Protokolliert wann welche Sperren angefordert werden 


-- Sitzung lschen, falls bereits vorhanden
IF EXISTS(SELECT * FROM sys.server_event_sessions WHERE name='SperrenZaehlen')
BEGIN
	DROP EVENT SESSION SperrenZaehlen ON SERVER;
END
GO
-- Sitzung anlegen
CREATE EVENT SESSION SperrenZaehlen ON SERVER 
	ADD EVENT sqlserver.lock_acquired
	(	WHERE sqlserver.database_id = 12  
			  AND -- Sperrtypen S or U or X or IS or IU or IX
			  (mode = 3 OR mode = 4 OR mode = 5 OR mode = 6 OR mode = 7 OR mode = 8) 
	) 
	-- Speichert die Anzahl, wie oft das Ereignis eingetreten ist
	ADD TARGET package0.event_counter,
	-- Speichert die Anzahl pro Sperrtyp
	ADD TARGET package0.histogram 
	(	SET filtering_event_name=N'sqlserver.lock_acquired',
				 source=N'mode',
				 source_type = 0
	)
-- Latenzzeit aus Demozwecken auf 10 Sekunden
WITH (MAX_DISPATCH_LATENCY=10 SECONDS);


-- Ausgabe der Konfiguration
SELECT	Sitzungen.name As Sitzung, Ereignisse.package As Paket, Ereignisse.name As Ereignis,
		Ereignisse.predicate As Prdikate, Aktionen.name As Aktionen, 
		Ziele.name As Ziele, Eigenschaften.value As Speicher
FROM	sys.server_event_sessions Sitzungen
		INNER JOIN sys.server_event_session_events Ereignisse 
				ON Sitzungen.event_session_id = Ereignisse.event_session_id
		INNER JOIN sys.server_event_session_actions Aktionen
				ON Sitzungen.event_session_id = Aktionen.event_session_id
		INNER JOIN sys.server_event_session_targets Ziele
				ON Sitzungen.event_session_id = Ziele.event_session_id
		INNER JOIN sys.server_event_session_fields Eigenschaften
				ON Sitzungen.event_session_id = Eigenschaften.event_session_id
			  AND Ziele.target_id = Eigenschaften.[object_id] 
WHERE	Sitzungen.name = 'SperrenZaehlen'
ORDER BY Ereignis, Ziele, Aktionen;


-- Sitzung starten
ALTER EVENT SESSION SperrenZaehlen ON SERVER STATE=START;



-- Testen
USE SNEK
GO

SELECT * FROM dbo.Artikel;
UPDATE dbo.Artikel SET Artikelname = 'Chai' WHERE [Artikel-Nr] = 1;
GO


-- Sitzung stoppen
-- ALTER EVENT SESSION SperrenZaehlen ON SERVER STATE=STOP;

