/* -------------------------------------------------
Beispielskript zur SNEK 2 im April 2013 in Nrnberg
Autor: Bernd Jungbluth
Keine Gewhrleistung, keine Haftung
------------------------------------------------- */

-- Auswerten der XEvent-Sitzung "TimeOuts"
-- Quelle: Ereignispaarbildung

-- Die Daten werden mit einer CTE ausgegeben, um das Ergbnis mit der DMF sys.dm_exec_query_plan zu ergnzen.
-- Die DMF sys.dm_exec_query_plan liefert den Ausfhrungsplan zur SQL-Anweisung.
-- Dabei wird die aktuelle Abfrage ber die SPID ausgeschlossen.


WITH cteErgebnis (Ereignis, Zeitpunkt, DatenbankID, Datenbank, SqlAnweisung, SessionID, 
				  PlanHandle, Benutzer, Client, xmlErgebnis)
AS
(
	SELECT 
			xmlWert.value('(@name)[1]', 'nvarchar(512)') AS Ereignis,
			DATEADD(hh, DATEDIFF(hh, GETUTCDATE(), CURRENT_TIMESTAMP), 
					xmlWert.value('(@timestamp)[1]', 'datetime2')) AS Zeitpunkt,	
			xmlWert.value('(action[@name="database_id"]/value)[1]', 'int') AS DatenbankID,
			xmlWert.value('(action[@name="database_name"]/value)[1]', 'nvarchar(256)') AS Datenbank,
			xmlWert.value('(data[@name="statement"]/value)[1]', 'nvarchar(max)') AS SqlAnweisung,
			xmlWert.value('(action[@name="session_id"]/value)[1]', 'int') AS SessionID,
			xmlWert.value('(action[@name="plan_handle"]/value)[1]', 'nvarchar(max)') AS PlanHandle,
			xmlWert.value('(action[@name="username"]/value)[1]', 'nvarchar(256)') AS Benutzer,
			xmlWert.value('(action[@name="client_hostname"]/value)[1]', 'nvarchar(256)') AS Client,
			Ergebnis 
	FROM	(
			 SELECT	CAST(Ziele.target_data as xml) Ergebnis
			 FROM	sys.dm_xe_session_targets Ziele
					INNER JOIN sys.dm_xe_sessions Sitzungen ON Sitzungen.address = Ziele.event_session_address
			 WHERE	Ziele.target_name = 'pair_matching' AND Sitzungen.name = 'TimeOuts'
			) Ergebnisdaten
			CROSS APPLY Ergebnis.nodes('//event') AS xmlErgebnis (xmlWert)
)
SELECT	Ereignis, Zeitpunkt, DatenbankID, Datenbank, SqlAnweisung, 
		SessionID, P.query_plan As Ausfuehrungsplan, Benutzer, Client, xmlErgebnis
FROM	cteErgebnis E
		OUTER APPLY sys.dm_exec_query_plan(CONVERT(varbinary(max), PlanHandle, 2)) P
WHERE	SessionID != @@SPID;






