/* -------------------------------------------------
Beispielskript zur SNEK 2 im April 2013 in Nrnberg
Autor: Bernd Jungbluth
Keine Gewhrleistung, keine Haftung
------------------------------------------------- */


-- Erstellen der XEvent-Sitzung "Deadlocks"
-- Protokolliert Deadlocks


-- Festlegen des Schwellenwerts fr blockierte Prozesse auf 5 Sekunden
-- Nun wird der Bericht fr einen Deadlock nur erstellt, wenn der Deadlock
-- lnger als 5 Sekunden besteht
EXECUTE sp_configure 'show advanced options', 1
GO
RECONFIGURE
GO
EXECUTE sp_configure 'blocked process threshold', 5
GO
RECONFIGURE
GO
EXECUTE sp_configure 'show advanced options', 0
GO
RECONFIGURE
GO


-- Sitzung lschen, falls bereits vorhanden
IF EXISTS(SELECT * FROM sys.server_event_sessions WHERE name='Deadlocks')
	DROP EVENT SESSION Deadlocks ON SERVER
GO
-- Sitzung anlegen
CREATE EVENT SESSION Deadlocks ON SERVER     
	ADD EVENT sqlserver.xml_deadlock_report 
	(	ACTION (sqlserver.sql_text, sqlserver.session_id,
				sqlserver.username, sqlserver.client_hostname)
	)
	ADD TARGET package0.event_file (SET filename=N'D:\SNEK2\Ergebnisse\Deadlocks.xel')
-- Latenzzeit aus Demozwecken auf 10 Sekunden
WITH (MAX_DISPATCH_LATENCY=10 SECONDS);


-- Ausgabe der Konfiguration
SELECT	Sitzungen.name As Sitzung, Ereignisse.package As Paket, Ereignisse.name As Ereignis,
		Ereignisse.predicate As Prdikate, Aktionen.name As Aktionen, 
		Ziele.name As Ziele, Eigenschaften.value As Speicher
FROM	sys.server_event_sessions Sitzungen
		INNER JOIN sys.server_event_session_events Ereignisse 
				ON Sitzungen.event_session_id = Ereignisse.event_session_id
		INNER JOIN sys.server_event_session_actions Aktionen
				ON Sitzungen.event_session_id = Aktionen.event_session_id
		INNER JOIN sys.server_event_session_targets Ziele
				ON Sitzungen.event_session_id = Ziele.event_session_id
		INNER JOIN sys.server_event_session_fields Eigenschaften
				ON Sitzungen.event_session_id = Eigenschaften.event_session_id
			  AND Ziele.target_id = Eigenschaften.[object_id] 
WHERE	Sitzungen.name = 'Deadlocks'
ORDER BY Ereignis, Ziele, Aktionen;


-- Sitzung starten
ALTER EVENT SESSION Deadlocks ON SERVER STATE=START;



-- Testen
USE SNEK
GO

SET DEADLOCK_PRIORITY HIGH;

DECLARE @i int = 1
WHILE @i < 10000
BEGIN
	BEGIN TRAN
	UPDATE Kunden SET Firma = 'Alfreds Neue Futterkiste' WHERE [Kunden-Code] = 'ALFKI'
	UPDATE Versandfirmen SET Firma = 'Slowly Express' WHERE [Firmen-Nr] = 1
	SET @i = @i + 1
	COMMIT TRAN
END


-- In einer neuen Abfrage ausfhren
USE SNEK
GO

SET DEADLOCK_PRIORITY LOW;

DECLARE @i int = 1
WHILE @i < 10000
BEGIN
	BEGIN TRAN
	UPDATE Versandfirmen SET Firma = 'Slowly Express' WHERE [Firmen-Nr] = 1
	UPDATE Kunden set Firma = 'Alfreds Neue Futterkiste' WHERE [Kunden-Code] = 'ALFKI'
	SET @i = @i + 1
	COMMIT TRAN
END



-- Sitzung stoppen
-- ALTER EVENT SESSION Deadlocks ON SERVER STATE=STOP;
