/* -------------------------------------------------
Beispielskript zur SNEK 2 im April 2013 in Nrnberg
Autor: Bernd Jungbluth
Keine Gewhrleistung, keine Haftung
------------------------------------------------- */


-- Erstellen der XEvent-Sitzung "AbgekuendigteFunktionen"
-- Protokolliert Funktionen, die als abgekndigt deklariert sind


-- Sitzung lschen, falls bereits vorhanden
IF EXISTS(SELECT name FROM sys.server_event_sessions WHERE name = 'AbgekuendigteFunktionen')
BEGIN
	DROP EVENT SESSION AbgekuendigteFunktionen ON SERVER;
END;
-- Sitzung anlegen
CREATE EVENT SESSION AbgekuendigteFunktionen ON SERVER
	-- Funktionen, die in einer zuknftigen Version, 
	-- aber nicht aus der nchsten Hauptversion entfernt werden
	ADD EVENT sqlserver.deprecation_announcement	 
	(	ACTION (sqlserver.sql_text, sqlserver.database_name,
				sqlserver.username, sqlserver.client_hostname)
		WHERE	sqlserver.database_id = 12
	),
	-- Funktionen, die aus der nchsten Hauptversion entfernt werden
	ADD EVENT sqlserver.deprecation_final_support 
	(	ACTION (sqlserver.sql_text, sqlserver.database_name, 
				sqlserver.username, sqlserver.client_hostname)
		WHERE	sqlserver.database_id = 12
	)
	ADD TARGET package0.event_file (SET filename='D:\SNEK2\Ergebnisse\AbgekuendigteFunktionen.xel')
-- Latenzzeit aus Demozwecken auf 10 Sekunden
WITH (MAX_DISPATCH_LATENCY=10 SECONDS);	


-- Ausgabe der Konfiguration
SELECT	Sitzungen.name As Sitzung, Ereignisse.package As Paket, Ereignisse.name As Ereignis,
		Ereignisse.predicate As Prdikate, Aktionen.name As Aktionen, 
		Ziele.name As Ziele, Eigenschaften.value As Speicher
FROM	sys.server_event_sessions Sitzungen
		INNER JOIN sys.server_event_session_events Ereignisse 
				ON Sitzungen.event_session_id = Ereignisse.event_session_id
		INNER JOIN sys.server_event_session_actions Aktionen
				ON Sitzungen.event_session_id = Aktionen.event_session_id
		INNER JOIN sys.server_event_session_targets Ziele
				ON Sitzungen.event_session_id = Ziele.event_session_id
		INNER JOIN sys.server_event_session_fields Eigenschaften
				ON Sitzungen.event_session_id = Eigenschaften.event_session_id
			  AND Ziele.target_id = Eigenschaften.[object_id] 
WHERE	Sitzungen.name = 'AbgekuendigteFunktionen'
ORDER BY Ereignis, Aktionen;


-- Sitzung starten
ALTER EVENT SESSION AbgekuendigteFunktionen ON SERVER STATE = START;


-- Testen
USE SNEK
GO

IF OBJECT_ID('EineTabelle') IS NOT NULL
	DROP TABLE dbo.EineTabelle
GO
CREATE TABLE dbo.EineTabelle (Beschreibung text, Dokument image);




-- Sitzung stoppen
-- ALTER EVENT SESSION AbgekuendigteFunktionen ON SERVER STATE = STOP;
						 
						 
						 
						 