/* -------------------------------------------------
Beispielskript zur SNEK 2 im April 2013 in Nrnberg
Autor: Bernd Jungbluth
Keine Gewhrleistung, keine Haftung
------------------------------------------------- */

-- Auswerten der XEvent-Sitzung "AbgekuendigteFunktionen"
-- Quelle: Ereignisdatei
-- Die Daten werden zunchst in eine Table-Variable geschrieben.
-- Anschlieend wird die Table-Variable mit zwei SQL-Anweisungen ausgewertet.


DECLARE @tabErgebnis TABLE
(
	ID int IDENTITY NOT NULL,
	Ereignis nvarchar(512) NULL,
	Zeitpunkt datetime2 NULL,
	Datenbank nvarchar(256) NULL,
	Funktion nvarchar(max) NULL,
	Information nvarchar(max) NULL,
	SqlAnweisung nvarchar(max) NULL,
	Benutzer nvarchar(256) NULL,
	Client nvarchar(256) NULL,
	Ergebnis xml
);
INSERT INTO @tabErgebnis (Ereignis, Zeitpunkt, Datenbank, Funktion, 
						  Information, SqlAnweisung, Benutzer, Client, Ergebnis)
SELECT	
		xmlWert.value('(event/@name)[1]', 'nvarchar(50)') As Ereignis,
		DATEADD(hh, DATEDIFF(hh, GETUTCDATE(), CURRENT_TIMESTAMP),
			xmlWert.value('(event/@timestamp)[1]', 'datetime2')) As Zeitpunkt,
		xmlWert.value('(event/action[@name="database_name"]/value)[1]', 'nvarchar(128)') As Datenbank,
		xmlWert.value('(event/data[@name="feature"]/value)[1]', 'nvarchar(max)') As Funktion,
		xmlWert.value('(event/data[@name="message"]/value)[1]', 'nvarchar(max)') As Information,
		xmlWert.value('(event/action[@name="sql_text"]/value)[1]', 'nvarchar(max)') As SqlAnweisung,
		xmlWert.value('(event/action[@name="username"]/value)[1]', 'nvarchar(256)') AS Benutzer,
		xmlWert.value('(event/action[@name="client_hostname"]/value)[1]', 'nvarchar(256)') AS Client,
		Ergebnis
FROM	
		(SELECT	CAST(event_data AS XML) Ergebnis
		 FROM	sys.fn_xe_file_target_read_file('D:\SNEK2\Ergebnisse\AbgekuendigteFunktionen*.xel', NULL, NULL, NULL)) Ergebnisdaten
		CROSS APPLY Ergebnis.nodes ('.') AS xmlErgebnis (xmlWert);


-- Detaillierte Auswertung 
SELECT	Ereignis, Zeitpunkt, Datenbank, Funktion, Information, 
		SqlAnweisung, Benutzer, Client, Ergebnis
FROM	@tabErgebnis


-- Auswertung mit Anzahl der abgekndigten Funktionen
SELECT	Ereignis, COUNT(Ereignis) As AnzVorkommen, Datenbank, Funktion, Information
FROM	@tabErgebnis
GROUP BY Ereignis, Datenbank, Funktion, Information
;



